Package com.smartgwt.client.types

# Enum HashAlgorithm

java.lang.Object
java.lang.Enum<HashAlgorithm>
com.smartgwt.client.types.HashAlgorithm

All Implemented Interfaces:
  `ValueEnum`, `Serializable`, `Comparable<HashAlgorithm>`, `Constable`

public enum HashAlgorithm extends Enum<HashAlgorithm> implements ValueEnum
Algorithms to use when hashing field values (see `DataSourceField.storeWithHash`). Note that the `MD5` and `SHA` algorithms are deprecated as secure hashes since they are vulnerable to collisions created by an attacker with current technology, though they may still be useful in detecting corruption due to faulty transmission or storage.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BCRYPT`
  bcrypt is a password hashing function designed by Niels Provos and David Mazieres, based on the Blowfish cipher.
  `MD5`
  Message Digest algorithm.
  `NONE`
  Don't hash values.
  `SHA`
  Secure Hashing Algorithm (SHA-1).
  `SHA_256`
  Secure Hashing Algorithm (SHA-256).
  `SHA_512`
  Secure Hashing Algorithm (SHA-512).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getValue()`
  `static HashAlgorithm`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static HashAlgorithm[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### MD5

    public static final HashAlgorithm MD5
    Message Digest algorithm. Deprecated as a secure hash.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "MD5".

  - ### SHA

    public static final HashAlgorithm SHA
    Secure Hashing Algorithm (SHA-1). Deprecated as a secure hash.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "SHA".

  - ### SHA_256

    public static final HashAlgorithm SHA_256
    Secure Hashing Algorithm (SHA-256).

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "SHA-256".

  - ### SHA_512

    public static final HashAlgorithm SHA_512
    Secure Hashing Algorithm (SHA-512).

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "SHA-512".

  - ### BCRYPT

    public static final HashAlgorithm BCRYPT
    bcrypt is a password hashing function designed by Niels Provos and David Mazieres, based on the Blowfish cipher.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "bcrypt".

  - ### NONE

    public static final HashAlgorithm NONE
    Don't hash values. Can be specified to avoid the default algorithm.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "none".

- ## Method Details

  - ### values

    public static HashAlgorithm[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static HashAlgorithm valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getValue

    public String getValue()
    Specified by:
      `getValue` in interface `ValueEnum`